package spamfilter;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import java.util.*;

/**
 * Handles groups of checkboxes associated together in
 * one panel.
 * @author Tom Ashley
 */
public class CheckBoxPanel extends JPanel implements ActionListener{
     protected JButton button;
	 
         /**
          * Creates an autonomous panel with one checkbox,
          * specified as checked or unchecked, with a given title.
          * @param title label for the check box
          * @param box1 the checkbox to be added to the panel
          * @param checked the default value for whether the box is checked
          * @param tbutton variable associated with the action listener
          */
	 public CheckBoxPanel(String title, JCheckBox box1, boolean checked,
	                      JButton tbutton) {
	      super();
		  button = tbutton;
		  createCheckBoxes(title, box1, checked);
	 }
	 
	 private void createCheckBoxes(String title, JCheckBox box1, boolean ch) {
	      if (title == null)
		       return;
			   
		  JPanel checkBoxPanel = new JPanel();
		  JLabel label1 = new JLabel(title + ":");
		  
		  //Arrange the layout
		  checkBoxPanel.setLayout(new GridBagLayout());
		  GridBagConstraints c = new GridBagConstraints();
		  checkBoxPanel.setBorder(BorderFactory.createEmptyBorder(10,10,10,10));
		  
		  c.gridx = 0;
		  c.gridy = 0;
		  checkBoxPanel.add(label1, c);
		  
		  c.gridx = 1;
		  c.gridy = 0;
		  checkBoxPanel.add(box1, c);
		  
		  box1.setSelected(ch);
		  box1.addActionListener(this);
		  add(checkBoxPanel);
	 }
	 
	 public void actionPerformed(ActionEvent e)
	 {
	      button.setEnabled(true);
	 }
}
