package spamfilter;
import java.io.*;
import java.util.*;

//This class displays the contents of Globals.probTableFile to the screen
/**
 * Displays the contents of Globals.probTableFile to the screen.
 * @author Matt Hansen
 */
class DisplayProb
{ 
   /**
    * Main method. Reads in the probability hashtable and builds
    * enumerations for the tokens and probabilities.  Iterates through
    * the enumerations and displays the contents of each.
    */
   public static void main(String[] args)
   {
      try {
         FileInputStream in = new FileInputStream(Globals.probTableFile);
         ObjectInputStream s = new ObjectInputStream(in);
         Hashtable spamProbs = (Hashtable) s.readObject();
         s.close();
         in.close();

         String token;
         Float  prob;
         Enumeration tokenList = spamProbs.keys();
         Enumeration probList = spamProbs.elements();

         while(tokenList.hasMoreElements())
         {
            token = (String) tokenList.nextElement();
            prob = (Float) probList.nextElement();
            System.out.println(token + " " + prob);
         }
      }
      catch (IOException e) {
        System.err.println(e);
      }
      catch (ClassNotFoundException e) {
         System.err.println(e);
      }
   }
}
