package spamfilter;

import java.io.*;
import java.util.*;

// Global options & settings for SpamBurglar
public class Globals {

    // Proxy + protocol settings
    public static int 		connectionBufferSize = 2000;
    public static String	CRLF = "\r\n";
    public static String	charEncoding = "US-ASCII";
    public static String 	serverType = "POP"; 	
    public static String	mailHost = "localhost";
    public static int		mailPort = 110;
    public static int		proxyPort = 5000;
    
    // THIS SHOULD BE TRUE, FOR SECURITY REASONS
    // true = only allow connections from the local host, not outside world!
    public static boolean	localhostOnly = true;

    // Spam filter settings	

    public static int           spamAction = 1;//1 = Mark, 2 = Delete
    public static float		spamThreshold = (float) 0.9;
    public static String	probTableFile = "spamfilter/prob_table";
    public static String	whiteListFile = "spamfilter/whiteList";
    public static String	spamCorpus = "spamfilter/spamcount";
    public static String	nonspamCorpus = "spamfilter/nonspamcount";
    public static boolean       trainMode = false;
    // Load settings
    public static void load(String confFile) {		
	String spamActionString = "Mark spam";//Delete = 2;

	Properties conf = new Properties();
	try {
	    // read in proxy settings from file
	    FileInputStream in = new FileInputStream(confFile);
	    conf.load(in); // load properties from file
	    in.close();
	} catch (IOException e) {
	    System.err.println("[Error] Could not find configuration file.");
	    System.err.println("        Using default settings instead.");
	}

	// Load properties, using defaults if property is missing
	connectionBufferSize = Integer.parseInt(
		conf.getProperty("ConnectionBufferSize", "1024"));
	charEncoding = conf.getProperty("CharacterEncoding", "US-ASCII");
	
	spamActionString = conf.getProperty("SpamAction", "Mark spam");
	if(spamActionString.equals("Delete spam"))
	   spamAction = 2;
	else if(spamActionString.equals("Mark spam")) spamAction = 1;
	
	Boolean train = new Boolean(conf.getProperty("Train", "false"));
	trainMode = train.booleanValue();	
	
	serverType = conf.getProperty("ServerType", "POP");
	mailHost = conf.getProperty("MailServerHost", "localhost");
	mailPort = Integer.parseInt(
		conf.getProperty("MailServerPort", "110"));
	proxyPort = Integer.parseInt(
		conf.getProperty("ProxyPort", "5000"));
    }
}
