// TO DO:
// * TAGGED needs to come from Globals!!!
//tagged should be replaced by spamAction
//it is an Int with 1 as mark and 2 as delete, currently


package spamfilter;

import java.io.*;
import java.util.*;

public class POPAnalyzer extends Analyzer {     
    // From class Analyzer:
    // * int state
    //    * 0 = normal
    //    * 1 = server response to mail request (RETR, TOP)
    //    * 2 = fetching mail from server
    // * boolean blockClientReq
    // * StringBuffer mailBuf
 

    // *************** THIS SHOULD BE IN GLOBALS & USER-SET **********
    private static final boolean TAGGED = true;
    // *****************************************************
    
    private int messageNum;
    private int topLines;
   
    // constructor
    public POPAnalyzer() {
	super();
	messageNum = -1;
	topLines = -1;
    }
 
    // reset state, etc.
    protected void reset() {
	super.reset(); // reset state, mailBuf, blockClientReq
	messageNum = -1;
	topLines = -1;
    }
    
    private int extractInt(String str, int pos) {
	String[] a = str.split(" ", 0);

	if(a.length >= pos) {
	    try {
		return Integer.parseInt(a[(pos-1)].trim());
	    } catch (NumberFormatException e) {}
	}    
	return -1;
    }
    
    // check commands, pass on if not mail; if mail, then apply spam filtering
    // techniques before sending the email message on to the client
    public void process(String cmd, ChannelInfo chInfo) throws IOException {

// for debugging: -------------
if(chInfo.isClient()) {
    System.out.print("C[" + state + "]: ");

//} else {
 //   System.out.print("S[" + state + "]: ");
    System.out.print(cmd);    
}
// ----------------------------
	
	if(state == 0) {	   
		if((cmd.length() > 4) &&
			(cmd.substring(0,4).equalsIgnoreCase("RETR") ||
			 cmd.substring(0,3).equalsIgnoreCase("TOP"))) {
		    // next cmd will be server response
	            state = 1;
		    blockClientReq = true;
		    messageNum = extractInt(cmd, 2);
		    topLines = extractInt(cmd, 3); // is negative, if RETR

		    // send TOP request as a RETR, so we see entire message
		    // otherwise, this is just the same RETR command
		    chInfo.write("RETR " + messageNum + Globals.CRLF);
		}
		else
		    chInfo.write(cmd);
	}
	else if(state == 1) {
	    if((cmd.length() >= 3) && (cmd.substring(0,3).equalsIgnoreCase("+OK")))    
		state = 2;					
	    else // -ERR/bad response from server    
		reset();
	    chInfo.write(cmd);	    
	}
	else { // state = 2	
	    if(!cmd.equals("." + Globals.CRLF)) { // part of message body
		mailBuf.append(cmd);
	    }
	    else { // last line in message, so create Email object

		Email em = new Email(mailBuf.toString(), messageNum);
		
		try { // Identify if this message is spam	
		    if(em != null) {
			if(SpamIdentifier.isSpam(em))			
			    em.markAsSpam();	
			sessionMail.put(new Integer(messageNum), em);		    
			// Writes out truncated message if this was a 
			// TOP request, otherwise writes out entire message body
			chInfo.write(em.asPopMail(topLines, TAGGED).toString());
		    }
		    		    
		    chInfo.write(cmd); // ".CRLF"
		    reset();
		    
		} catch (IOException e) {
		    e.printStackTrace();
		}
	    }
	}
    }    
}
