/*
     SpinnerPanel.java by Tom Ashley
	 for CS400-SpamBurglar
*/

package spamfilter;	 
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import java.util.*;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import java.io.*;
import java.lang.Object.*;

/**
 * Handles Spinners for the SpamGUI.java config panel. 
 */
public class SpinnerPanel extends JPanel {
     protected JSpinner spinner;
	 
	 /**
	  * Creates a spinner panel. 
	  * @param title The name of the spinner panel.
	  * @param spinner1 The spinner itself.
	  */
     public SpinnerPanel(String title, JSpinner spinner1) {
	      super();
		  spinner = spinner1;
		  createSpinner(title, spinner1);
	 }
	 
	 private void createSpinner(String title, JSpinner spinner1) {
	      if (title.length() < 1)
		       return;
		  
		  JPanel spinnerPanel = new JPanel();
		  JLabel label1 = new JLabel(title);
		  
		  spinnerPanel.setLayout(new GridBagLayout());
		  GridBagConstraints c = new GridBagConstraints();
		  spinnerPanel.setBorder(BorderFactory.createEmptyBorder(10,10,10,10));
		  
		  c.gridx = 0;
		  c.gridy = 0;
		  spinnerPanel.add(label1, c);
		  
		  c.gridx = 1;
		  c.gridy = 0;
		  spinnerPanel.add(spinner1, c);
		  
		  add(spinnerPanel);
	 }
}
