import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import java.util.*;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

/**
* Handles Text Panels for the SpamGUI.java config panel. 
* @author Tom Ashley and Matt Hansen
*/
public class TextPanel extends JPanel implements ChangeListener {
     protected JTextField textField1;
	 
	 /**
	  * Creates the text panel.
	  * @param title The title of the text panel.
	  * @param contents What is initially containted in the text panel.
	  */
	 public TextPanel(String title, String contents) {
	      super();
		  createTextPanel(title, contents);
	 }
	 
	 private void createTextPanel(String title, String contents) {
	      if (title.length() < 1)
		       return;
			   
		  JPanel textPanel = new JPanel();
		  JLabel label1 = new JLabel(title + ":");
		  textField1 = new JTextField(contents);
		  
		  //textField1.addChangeListener(this);
		  
		  //Arrange the layout of the text panel
		  textPanel.setLayout(new GridBagLayout());
		  GridBagConstraints c = new GridBagConstraints();
		  textPanel.setBorder(BorderFactory.createEmptyBorder(10,10,10,10));
		  
		  c.gridx = 0;
		  c.gridy = 0;
		  textPanel.add(label1, c);
		  
		  c.gridx = 1;
		  c.gridy = 0;
		  textPanel.add(textField1, c);
		  
		  add(textPanel);
	 }
	 
	 public void stateChanged(ChangeEvent e) {
	      //System.out.println(textField1.getText());
		  
	 }
}
