package spamfilter;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import java.util.*;
import java.io.*;
import java.lang.Object.*;

/**
 * Handles the port and host text panels for the config panel of SpamGUI.java. 
 */
public class TextPanelGroup extends JPanel {
	 
	 /**
	  * Creates a text panel group of three: proxy port, mail port, and host.
	  * @param mailHost Not Used.
	  * @param mPort Not Used.
	  * @param pPort Not Used.
	  * @param textField1 The first text field.
	  * @param textField2 The second text field.
	  * @param textField3 The third text field. 
	  */
	 public TextPanelGroup(String mailHost, String mPort, String pPort,
	                       JTextField textField1, JTextField textField2,
			               JTextField textField3) {
	      super();
		  createTextPanelGroup(mailHost, mPort, pPort, textField1, textField2,
		                       textField3);
	 }
	 
	 private void createTextPanelGroup(String mailHost, String mPort,
			                           String pPort, JTextField textField1,
			                           JTextField textField2,
									   JTextField textField3) {
	      JPanel group = new JPanel();
		  group.setLayout(new GridBagLayout());
		  GridBagConstraints c = new GridBagConstraints();
		  //group.setPreferredSize(new Dimension(100,100));
		  //group.setMinimumSize(new Dimension(100,100));
		  
		  
		  JPanel textPanel1 = new JPanel();
		  JLabel label1 = new JLabel("Server Name:");
		  
		  textPanel1.setLayout(new GridBagLayout());
		  textPanel1.setBorder(BorderFactory.createEmptyBorder(10,10,10,10));
		  
		  JPanel textPanel2 = new JPanel();
		  JLabel label2 = new JLabel("Port:");
		  //textField2 = new JTextField(mPort);
		  
		  textPanel2.setLayout(new GridBagLayout());
		  textPanel2.setBorder(BorderFactory.createEmptyBorder(10,10,10,10));
		  
		  JPanel textPanel3 = new JPanel();
		  JLabel label3 = new JLabel("Proxy Port:");
		  //textField3 = new JTextField(pPort);
		  
		  textPanel3.setLayout(new GridBagLayout());
		  textPanel3.setBorder(BorderFactory.createEmptyBorder(10,10,10,10));
		  
		  c.gridx = 0;
		  c.gridy = 0;
		  c.anchor = GridBagConstraints.LINE_END;
		  textPanel1.add(label1, c);
		  
		  c.gridx = 1;
		  c.gridy = 0;
		  c.anchor = GridBagConstraints.LINE_END;
		  textPanel1.add(textField1, c);
		  
		  c.gridx = 0;
		  c.gridy = 0;
		  c.anchor = GridBagConstraints.LINE_END;
		  textPanel2.add(label2, c);
		  
		  c.gridx = 1;
		  c.gridy = 0;
		  c.anchor = GridBagConstraints.LINE_END;
		  textPanel2.add(textField2, c);
		  
		  c.gridx = 0;
		  c.gridy = 0;
		  c.anchor = GridBagConstraints.LINE_END;
		  textPanel3.add(label3, c);
		  
		  c.gridx = 1;
		  c.gridy = 0;
		  c.anchor = GridBagConstraints.LINE_END;
		  textPanel3.add(textField3, c);
		  
		  c.gridx = 0;
		  c.gridy = 0;
		  group.add(textPanel1, c);
		  
		  c.gridx = 0;
		  c.gridy = 1;
		  group.add(textPanel2, c);
		  
		  c.gridx = 0;
		  c.gridy = 2;
		  group.add(textPanel3, c);
		  
		  add(group);
	 }
}
