/*
   Validate.java by Tom Ashley and Matt Hansen for CS 400 - SpamFilter
*/
package spamfilter;

import java.util.*;
import java.io.*;

/**
* Uses 10-fold cross-validation to check spamfilter accuracy. This program 
* takes 10 files (List1 - List10) of only spam or only nonspam, trains on 9 of 
* them, and tests the final one. It was used to check the accuracy of our spam 
* filter.
* @author Tom Ashley and Matt Hansen
*/
public class Validate
{
   /**
   * Trains on 9 files, tests on the other one, and outputs the results. It 
   * reads in command line arguments in the form
   * <p> <p>
   * Validate testFile spam/nonspam
   * <p> <p>
   * where testFile is the name of the file to test, and the files consist of 
   * spam or nonspam. Requires files in the format provided by 
   * MakeTestFiles.java, which is to say emails stored as members of the Email 
   * class in hashtables.
   * @param args In the form: Validate testFile spam/nonspam
   * @throws IOException if an input or output exception occurs.
   */
   public static void main(String[] args) throws IOException
   {
      if (args.length != 2 || (!args[1].equals("spam") && 
                               !args[1].equals("nonspam")))
      {
         System.err.println("Wrong number of arguments.");
         System.err.println("Format is:");
         System.err.println("Validate testfile spam/nospam");
      }
      boolean markAsSpam = false;
      if (args[1].equals("spam"))
         markAsSpam = true;

      String[] trainfiles = new String[9];
      
      if (args[0].equals("List1"))
      {
         trainfiles[0] = "List10";
	 trainfiles[1] = "List2";
	 trainfiles[2] = "List3";
	 trainfiles[3] = "List4";
	 trainfiles[4] = "List5";
	 trainfiles[5] = "List6";
	 trainfiles[6] = "List7";
	 trainfiles[7] = "List8";
	 trainfiles[8] = "List9";
      }
      else if (args[0].equals("List2"))
      {
         trainfiles[0] = "List1";
	 trainfiles[1] = "List3";
	 trainfiles[2] = "List4";
	 trainfiles[3] = "List5";
	 trainfiles[4] = "List6";
	 trainfiles[5] = "List7";
	 trainfiles[6] = "List8";
	 trainfiles[7] = "List9";
	 trainfiles[8] = "List10";
      }
      else if (args[0].equals("List3"))
      {
         trainfiles[0] = "List1";
	 trainfiles[1] = "List2";
	 trainfiles[2] = "List4";
	 trainfiles[3] = "List5";
	 trainfiles[4] = "List6";
	 trainfiles[5] = "List7";
	 trainfiles[6] = "List8";
	 trainfiles[7] = "List9";
	 trainfiles[8] = "List10";
      }
      else if (args[0].equals("List4"))
      {
	 trainfiles[0] = "List1";
	 trainfiles[1] = "List2";
	 trainfiles[2] = "List3";
	 trainfiles[3] = "List5";
	 trainfiles[4] = "List6";
	 trainfiles[5] = "List7";
	 trainfiles[6] = "List8";
	 trainfiles[7] = "List9";
	 trainfiles[8] = "List10";
      }
      else if (args[0].equals("List5"))
      {
	 trainfiles[0] = "List1";
	 trainfiles[1] = "List2";
	 trainfiles[2] = "List3";
	 trainfiles[3] = "List4";
	 trainfiles[4] = "List6";
	 trainfiles[5] = "List7";
	 trainfiles[6] = "List8";
	 trainfiles[7] = "List9";
	 trainfiles[8] = "List10";
      }
      else if (args[0].equals("List6"))
      {
	 trainfiles[0] = "List1";
	 trainfiles[1] = "List2";
	 trainfiles[2] = "List3";
	 trainfiles[3] = "List4";
	 trainfiles[4] = "List5";
	 trainfiles[5] = "List7";
	 trainfiles[6] = "List8";
	 trainfiles[7] = "List9";
	 trainfiles[8] = "List10";
      }
      else if (args[0].equals("List7"))
      {
	 trainfiles[0] = "List1";
	 trainfiles[1] = "List2";
	 trainfiles[2] = "List3";
	 trainfiles[3] = "List4";
	 trainfiles[4] = "List5";
	 trainfiles[5] = "List6";
	 trainfiles[6] = "List8";
	 trainfiles[7] = "List9";
	 trainfiles[8] = "List10";
      }
      else if (args[0].equals("List8"))
      {
	 trainfiles[0] = "List1";
	 trainfiles[1] = "List2";
	 trainfiles[2] = "List3";
	 trainfiles[3] = "List4";
	 trainfiles[4] = "List5";
	 trainfiles[5] = "List6";
	 trainfiles[6] = "List7";
	 trainfiles[7] = "List9";
	 trainfiles[8] = "List10";
      }
      else if (args[0].equals("List9"))
      {
	 trainfiles[0] = "List1";
	 trainfiles[1] = "List2";
	 trainfiles[2] = "List3";
	 trainfiles[3] = "List4";
	 trainfiles[4] = "List5";
	 trainfiles[5] = "List6";
	 trainfiles[6] = "List7";
	 trainfiles[7] = "List8";
	 trainfiles[8] = "List10";
      }
      else if (args[0].equals("List10"))
      {
	 trainfiles[0] = "List1";
	 trainfiles[1] = "List2";
	 trainfiles[2] = "List3";
	 trainfiles[3] = "List4";
	 trainfiles[4] = "List5";
	 trainfiles[5] = "List6";
	 trainfiles[6] = "List7";
	 trainfiles[7] = "List8";
	 trainfiles[8] = "List9";
      }
      else
      {
         System.err.println("Input file name is not legitimate.");
         System.err.println("Must be 'ListX' where X is between");
         System.err.println("1 and 10, inclusive");
      }

      try
      {
         ObjectInputStream data1 = new ObjectInputStream(
            new FileInputStream(trainfiles[0]));
         ObjectInputStream data2 = new ObjectInputStream(
            new FileInputStream(trainfiles[1]));
         ObjectInputStream data3 = new ObjectInputStream(
            new FileInputStream(trainfiles[2]));
         ObjectInputStream data4 = new ObjectInputStream(
            new FileInputStream(trainfiles[3]));
         ObjectInputStream data5 = new ObjectInputStream(
            new FileInputStream(trainfiles[4]));
         ObjectInputStream data6 = new ObjectInputStream(
            new FileInputStream(trainfiles[5]));
	 ObjectInputStream data7 = new ObjectInputStream(
            new FileInputStream(trainfiles[6]));
         ObjectInputStream data8 = new ObjectInputStream(
            new FileInputStream(trainfiles[7]));
         ObjectInputStream data9 = new ObjectInputStream(
            new FileInputStream(trainfiles[8]));

         Hashtable h1 = (Hashtable) data1.readObject();
         Hashtable h2 = (Hashtable) data2.readObject();
         Hashtable h3 = (Hashtable) data3.readObject();
         Hashtable h4 = (Hashtable) data4.readObject();
         Hashtable h5 = (Hashtable) data5.readObject();
         Hashtable h6 = (Hashtable) data6.readObject();
         Hashtable h7 = (Hashtable) data7.readObject();
	     Hashtable h8 = (Hashtable) data8.readObject();
         Hashtable h9 = (Hashtable) data9.readObject();
		   
         data1.close();
	 data2.close();
	 data3.close();
	 data4.close();
	 data5.close();
	 data6.close();
	 data7.close();
	 data8.close();
	 data9.close();
		   	   
         Vector fullList = new Vector();
	 Email temp;
		   
	 Enumeration e1 = h1.elements();
	 Enumeration e2 = h2.elements();
         Enumeration e3 = h3.elements();
         Enumeration e4 = h4.elements();
	 Enumeration e5 = h5.elements();
         Enumeration e6 = h6.elements();
         Enumeration e7 = h7.elements();
	 Enumeration e8 = h8.elements();
	 Enumeration e9 = h9.elements();

         while(e1.hasMoreElements())
	 {
	    temp = (Email) e1.nextElement();
            if (markAsSpam)
               temp.markAsSpam();
            else
	       temp.markAsNonspam();
            fullList.add(temp);
	 }
         h1.clear();
         while(e2.hasMoreElements())
         {
            temp = (Email) e2.nextElement();
            if (markAsSpam)
               temp.markAsSpam();
            else
	       temp.markAsNonspam();
	    fullList.add(temp);
	 }
         h2.clear();
	 while(e3.hasMoreElements())
	 {
	    temp = (Email) e3.nextElement();
	    if (markAsSpam)
               temp.markAsSpam();
            else
               temp.markAsNonspam();
	    fullList.add(temp);
	 }
         h3.clear();
         while(e4.hasMoreElements())
	 {
	    temp = (Email) e4.nextElement();
	    if (markAsSpam)
               temp.markAsSpam();
            else
               temp.markAsNonspam();
	    fullList.add(temp);
	 }
         h4.clear();
	 while(e5.hasMoreElements())
	 {
	    temp = (Email) e5.nextElement();
            if (markAsSpam)
               temp.markAsSpam();
            else
	       temp.markAsNonspam();
            fullList.add(temp);
	 }
         h5.clear();
	 while(e6.hasMoreElements())
	 {
	    temp = (Email) e6.nextElement();
	    if (markAsSpam)
               temp.markAsSpam();
            else
               temp.markAsNonspam();
	    fullList.add(temp);
	 }
         h6.clear();
	 while(e7.hasMoreElements())
	 {
	    temp = (Email) e7.nextElement();
            if (markAsSpam)
               temp.markAsSpam();
            else
	       temp.markAsNonspam();
	    fullList.add(temp);
	 }
         h7.clear();
         while(e8.hasMoreElements())
	 {
	    temp = (Email) e8.nextElement();
	    if (markAsSpam)
               temp.markAsSpam();
            else
               temp.markAsNonspam();
	    fullList.add(temp);
	 }
         h8.clear();
	 while(e9.hasMoreElements())
	 {
	    temp = (Email) e9.nextElement();
	    if (markAsSpam)
               temp.markAsSpam();
            else
               temp.markAsNonspam();
	    fullList.add(temp);
	 }
         h9.clear();

	 // Train the filter on the data
         SpamIdentifier.updateCorpus(fullList);

         // Now run the test data through the identifier
         ObjectInputStream data10 = new ObjectInputStream(
            new FileInputStream(args[0]));
         Hashtable h10 = (Hashtable) data10.readObject();
         data10.close();
	 Enumeration e10 = h10.elements();
         int spam = 0;
         int nonspam = 0;
         while (e10.hasMoreElements())
         {
            temp = (Email) e10.nextElement();
            if (SpamIdentifier.isSpam(temp))
               spam++;
            else
            {
               nonspam++;
               if (markAsSpam)
               // if we say it was spam but the filter says it isn't
               {
                  System.out.println(temp.getSender());
                  System.out.println(temp.getSubject());
                  System.out.println(temp.getMessageBody());
               }
            }
         }
         h10.clear();
         System.out.println("# messages identified as spam: " + spam);
         System.out.println("# messages identified as nonspam: " + nonspam);
      }
      catch(IOException e)
      {
         System.err.println(e);
      }
      catch(ClassNotFoundException e)
      {
	 System.err.println(e);
      }
   }
}
