package spamfilter;
import java.io.*;
import java.util.*;

/**
 * A test program which makes or modifies a white list from the terminal window.
 * This program is for testing white list functionality without having to deal 
 * with GUI code. Modifies the actual white list specfied in Globals.java. Not 
 * used in the SpamBurglar program.
 * @author Matt Hansen
 */
class makeWhiteList
{
     public static void main(String[] args) {

	//try to read whitelist
	try {
         FileInputStream in = new FileInputStream(Globals.whiteListFile);
         ObjectInputStream s = new ObjectInputStream(in);
	 Hashtable whiteList = (Hashtable) s.readObject();
	 s.close();
	 in.close();
         System.out.println("About to go to update process");
	 updateWhiteList(whiteList);
         FileInputStream in2 = new FileInputStream(Globals.whiteListFile);
         ObjectInputStream s2 = new ObjectInputStream(in2);
         Hashtable newWhiteList = (Hashtable) s2.readObject();
         displayWhiteList(newWhiteList);
 	}
        catch(IOException e) {
	  System.err.println( "Whitelist doesn't exist; creating now");
	  createWhiteList();
        }
        catch(ClassNotFoundException e) {
	   System.err.println(e);
        }
    }

/**
 * A text-based interface for when the white list already exists. 
 * @param whiteList The existing white list
 */
public static void updateWhiteList(Hashtable whiteList)  {
     //display whitList to screen, ask user for updates, write out
     //This should eventually be replaced by a GUI
   try {
     String resp = null;
     BufferedReader stdin = 
       new BufferedReader(new InputStreamReader(System.in));

     do {
     System.out.println("");
     System.out.println("Enter address to add to list ('Q' to quit)");
     System.out.print("> ");
     resp = stdin.readLine();
     if(resp.length() < 0) {
	System.out.println("Nothing was entered.");
     }
     else if(!resp.equalsIgnoreCase("Q")) {
	whiteList.put(resp, "white");
     }
     } while((!resp.equalsIgnoreCase("Q")));
     System.out.println("");
     System.out.println("Writing White List");
     FileOutputStream out = new FileOutputStream(Globals.whiteListFile);
     ObjectOutputStream oOut = new ObjectOutputStream(out);
     oOut.writeObject(whiteList);
     oOut.close();
     out.close();
    }
    catch (IOException e) {
      System.out.println("Error: coulr not read from stdin");
      System.exit(-1);
    }

}

/**
 * A text-based interface for when the white list does not yet exist. Could be 
 * modified so either createWhiteList or updateWhiteList was not necessary, but 
 * since this wass test code, I didnt bother.
 */
public static void createWhiteList() {

   Hashtable whiteList = new Hashtable();
   try {
     String resp = null;
     BufferedReader stdin = 
       new BufferedReader(new InputStreamReader(System.in));

     do {
     System.out.println("");
     System.out.println("Enter address to add to list ('Q' to quit)");
     System.out.print("> ");
     resp = stdin.readLine();
     if(resp.length() < 0) {
	System.out.println("Nothing was entered.");
     }
     else if(!resp.equalsIgnoreCase("Q")) {
	whiteList.put(resp, "white");
     }
     } while((!resp.equalsIgnoreCase("Q")));
     System.out.println("");
     System.out.println("Writing White List");
     FileOutputStream out = new FileOutputStream(Globals.whiteListFile);
     ObjectOutputStream oOut = new ObjectOutputStream(out);
     oOut.writeObject(whiteList);
     oOut.close();
     out.close();
    }
    catch (IOException e) {
      System.out.println("Error: coulr not read from stdin");
      System.exit(-1);
    }

}

/**
 * Displays the white list on the screen to make sure it has been correctly 
 * modified. 
 * @param whiteList The white list hashtable.
 */
public static void displayWhiteList(Hashtable whiteList) {

      Enumeration items = whiteList.keys();
      Enumeration elems = whiteList.elements();
      while(items.hasMoreElements()) {
         System.out.println(items.nextElement() + " " 
                + elems.nextElement());
      
   }
}

}
